#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#include "cattura_txt.h"
#include "elementi.h"
#include "load.h"


#define MASSIMO 30

/* La nostra struttura che associa ad ogni numero di deposito un Nome ed un Comando */

struct deposito
{
  gchar *Nome;
  gchar *Comando;
};

struct deposito *pn, numero[MASSIMO];


gint Selezione;
gchar Variazione[1];
gchar Nome[RECORD_LUN], Comando[RECORD_LUN];
gchar *Pn, *Pc;
gint Modo_Menu = 1;


void
on_nuovo1_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  if (Modo_Menu == 0)
  {
    strcpy (Variazione, "NO");
    Insermod = create_insermod ();
    gtk_widget_show (Insermod);
    gtk_widget_set_sensitive (Base, FALSE);
  }

}


void
on_varia1_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  if (Modo_Menu == 0)
  {
    strcpy (Variazione, "SI");
    Insermod = create_insermod ();
    gtk_widget_show (Insermod);
    gtk_widget_set_sensitive (Base, FALSE);
  }

}


void
on_lista1_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  if (Modo_Menu == 0)
  {
    /* La lista precedente va distrutta */
    if (Lista != NULL)
      gtk_widget_destroy (Lista);
    Lista = create_lista ();
    /* Prima la carico e poi la mostro */
    c_list_load ();
    gtk_widget_show (Lista);
  }
}


void
on_uscita1_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  gtk_exit (0);
}


void
on_nuovo_clicked (GtkButton * button, gpointer user_data)
{
  if (Modo_Menu == 0)
  {
    strcpy (Variazione, "NO");
    Insermod = create_insermod ();
    gtk_widget_show (Insermod);
    gtk_widget_set_sensitive (Base, FALSE);
  }
}


void
on_lista_clicked (GtkButton * button, gpointer user_data)
{
  if (Modo_Menu == 0)
  {
    /* la lista precedente va distrutta */
    if (Lista != NULL)
      gtk_widget_destroy (Lista);
    Lista = create_lista ();
    /* prima la carico e poi la mostro */
    c_list_load ();
    gtk_widget_show (Lista);
  }
}


void
on_chiudi_win2_clicked (GtkButton * button, gpointer user_data)
{
  /* Se ogni volt la creo 
   * ogni volta lo devo distruggere
   */
  gtk_widget_destroy (Insermod);
  gtk_widget_set_sensitive (Base, TRUE);


  file_load (Base);

}


void
on_chiudi_win3_clicked (GtkButton * button, gpointer user_data)
{
  /* Se ogni volta ne creo una le altre bisogna distruggerle */
  gtk_widget_destroy (Lista);
  Lista = NULL;
}


void
on_varia_clicked (GtkButton * button, gpointer user_data)
{
  if (Modo_Menu == 0)
  {
    strcpy (Variazione, "SI");
    Insermod = create_insermod ();
    gtk_widget_show (Insermod);
    gtk_widget_set_sensitive (Base, FALSE);
  }
}



gboolean
on_entryfor_key_press_event (GtkWidget * widget,
			     GdkEventKey * event, gpointer user_data)
{
  GtkWidget *entry;
  GdkCursor *cursor;
  char c;
  cursor = gdk_cursor_new (GDK_PENCIL);

  gdk_window_set_cursor (event->window, cursor);

  pn = numero;

  if (strcmp (Variazione, "NO") == 0)
  {

    pn->Nome = get_testo (widget, "entryfor");

    if (event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
    {
      if (*pn->Nome)
      {
	if ((c = isalpha (*pn->Nome) != 0))
	{
	  printf ("Fornitore %s\n", pn->Nome);
	  entry = lookup_widget (Insermod, "entry_com");
	  gtk_window_set_focus (GTK_WINDOW (Insermod), entry);
	  gtk_entry_set_text (GTK_ENTRY (entry), "");
	}
	else
	  gdk_beep ();
      }
      else
	gdk_beep ();
    }
  }
  else
  {
    Pn = Nome;
    Pn = get_testo (widget, "entryfor");
    printf ("Variazione NOME\n");
    if (event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
    {
      if (pn != NULL)
      {
	if ((c = isalpha (*Pn) != 0))
	{
	  printf ("Fornitore %s\n", Pn);
	  entry = lookup_widget (Insermod, "entry_com");
	  gtk_window_set_focus (GTK_WINDOW (Insermod), entry);
	  gtk_entry_set_text (GTK_ENTRY (entry), "");
	}
	else
	  gdk_beep ();
      }
      else
	gdk_beep ();
    }

  }

  return FALSE;
}


gboolean
on_entry_com_key_press_event (GtkWidget * widget,
			      GdkEventKey * event, gpointer user_data)
{
  GdkCursor *cursor;
  char c;
  pn = numero;
  cursor = gdk_cursor_new (GDK_PENCIL);
  gdk_window_set_cursor (event->window, cursor);


  if (strcmp (Variazione, "NO") == 0)
  {
    pn->Comando = get_testo (widget, "entry_com");
    if (event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
    {
      if (*pn->Comando)
      {
	if ((c = isalpha (*pn->Comando) != 0))
	{
	  printf ("Fornitore %s\n", pn->Nome);
	  printf ("Comando: %s\n", pn->Comando);
	  Conferma = create_Conferma ();
	  gtk_widget_show (Conferma);
	}
	else
	  gdk_beep ();
      }
      else
	gdk_beep ();
    }
  }

  else
  {
    Pc = Comando;
    Pc = get_testo (widget, "entry_com");
    printf ("Variazione COMANDO\n");
    if (event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
    {
      if (Pc != NULL)
      {
	if ((c = isalpha (*Pc) != 0))
	{
	  printf ("Fornitore %s\n", Pn);
	  printf ("Comando: %s\n", Pc);
	  Conferma = create_Conferma ();
	  gtk_widget_show (Conferma);

	}
	else
	  gdk_beep ();
      }
      else
	gdk_beep ();
    }
  }

  return FALSE;
}


gboolean
on_entry1_key_press_event (GtkWidget * widget,
			   GdkEventKey * event, gpointer user_data)
{
  GtkWidget *entry;
  GtkWidget *entry_1;
  char *d;
  int last;

  if (event->length > 0)
  {
    d = event->string;
    switch (*d = toupper (*d))
    {
    case 'S':
      gtk_widget_hide (Conferma);
      printf ("Entry: %s\n", d);

      if (strcmp (Variazione, "NO") == 0)
      {
	last = conta_elementi ();
	if (last < MAX_N_ELEMENTI)
	{
	  /* Aggiungiamone unaltro */
	  modifica_elemento (last, pn->Nome, pn->Comando);

	  Altro = create_altro ();
	  gtk_widget_show (Altro);
	}
	else
	{

	  /* Questo caso non e` ancora previsto */
	  g_print ("\nNon puoi piu` aggiungere nessuna altra voce\n");

	}
      }
      else
      {
	/* Modifico */
	modifica_elemento (Selezione, Pn, Pc);

	/* Attivo */
	gtk_widget_set_sensitive (Base, TRUE);

	/* Chiudo */
	gtk_widget_destroy (Insermod);

	/* Ricarico la lista */
	file_load (Base);
      }
      break;

    case 'N':
      gtk_widget_hide (Conferma);
      entry = lookup_widget (Insermod, "entryfor");
      gtk_window_set_focus (GTK_WINDOW (Insermod), entry);
      entry_1 = lookup_widget (Insermod, "entry_com");
      gtk_entry_set_text (GTK_ENTRY (entry), "");
      gtk_entry_set_text (GTK_ENTRY (entry_1), "");
      printf ("Entry: %s\n", d);
      break;

    default:
      gdk_beep ();
    }
  }
  return FALSE;
}


gboolean
on_base_delete_event (GtkWidget * widget,
		      GdkEvent * event, gpointer user_data)
{
  gtk_exit (0);
  return FALSE;
}


gboolean
on_entry2_key_press_event (GtkWidget * widget,
			   GdkEventKey * event, gpointer user_data)
{
  GtkWidget *entry;
  GtkWidget *entry_1;
  char *d;
  int linee;
  if (event->length > 0)
  {
    d = event->string;
    switch (*d = toupper (*d))
    {
    case 'S':
      gtk_widget_destroy (Altro);
      printf ("Entry: %s\n", d);

      /* Conto gli items da pulire */
      linee = conta_elementi ();

      /* Li pulisco */
      gtk_list_clear_items (GTK_LIST (list), 0, MAX_N_ELEMENTI);

      /* Ricarico la lista */
      file_load (Base);

      entry = lookup_widget (Insermod, "entryfor");
      gtk_window_set_focus (GTK_WINDOW (Insermod), entry);
      entry_1 = lookup_widget (Insermod, "entry_com");
      gtk_entry_set_text (GTK_ENTRY (entry), "");
      gtk_entry_set_text (GTK_ENTRY (entry_1), "");
      break;

    case 'N':
      gtk_widget_destroy (Altro);
      gtk_widget_destroy (Insermod);

      /* Riattiviamo base */
      gtk_widget_set_sensitive (Base, TRUE);

      /* Conto gli items da pulire */
      linee = conta_elementi ();

      /* Li pulisco */
      /* gtk_list_clear_items(GTK_LIST(list), 0, linee); */
      gtk_list_clear_items (GTK_LIST (list), 0, MAX_N_ELEMENTI);

      /* Ricarico la lista */
      file_load (Base);

      printf ("Entry: %s\n", d);
      break;
    default:
      gdk_beep ();
    }
  }



  return FALSE;
}

void
on_list1_select_child (GtkList * list, GtkWidget * widget, gpointer user_data)
{
  gchar *stringa;

  if (list->selection)
  {
    stringa =
      (gchar *) gtk_object_get_data ((list->selection)->data, "Return_Value");
    Selezione = atoi (stringa);
    g_print ("Item Selezionato %d\n", Selezione);

    if (Modo_Menu == 1)
    {
      char comando[64];
      printf ("Select %d (%s)\n", Selezione, get_elemento (Selezione, E_CMD));
      sprintf (comando, "./%s", get_elemento (Selezione, E_CMD));
      gtk_widget_hide (Base);
      while (gtk_events_pending ())
	gtk_main_iteration ();
      system (comando);
      gtk_widget_show (Base);
      // gtk_exit(0);
    }
  }
}


gboolean
on_insermod_delete_event (GtkWidget * widget,
			  GdkEvent * event, gpointer user_data)
{
  gtk_widget_set_sensitive (Base, TRUE);
  return FALSE;
}


void
on_out_clicked (GtkButton * button, gpointer user_data)
{
  if (Modo_Menu == 0)
  {
    gdk_beep ();
    eli_conf = create_eli_conf ();
    gtk_widget_show (eli_conf);
  }
}
void
on_banner_clicked (GtkButton * button, gpointer user_data)
{
  banner = create_banner ();
  gtk_widget_show (banner);
}

void
on_uscita_clicked (GtkButton * button, gpointer user_data)
{
  gtk_exit (0);

}

void
on_radio_menu_toggled (GtkToggleButton * togglebutton, gpointer user_data)
{
  if (GTK_TOGGLE_BUTTON (togglebutton)->active)
    printf ("MENU ATTIVO\n");
  Modo_Menu = 1;
}


void
on_radio_setup_toggled (GtkToggleButton * togglebutton, gpointer user_data)
{
  if (GTK_TOGGLE_BUTTON (togglebutton)->active)
     printf ("SETUP ATTIVO\n");
  Modo_Menu = 0;

}


void
on_button1_clicked (GtkButton * button, gpointer user_data)
{
  gtk_widget_destroy (eli_conf);

  /* Cancello */
  g_print ("\nEliminazione elemento %d\n", Selezione);
  cancella_elemento (Selezione);

  /* Ricarico la lista */
  file_load (Base);
}


void
on_button2_clicked (GtkButton * button, gpointer user_data)
{
  gtk_widget_hide (eli_conf);
}

void
on_lista_destroy (GtkObject * object, gpointer user_data)
{
  /* Il puntatore va resettato NULL */
  Lista = NULL;
}

