#include <stdio.h>
#include <string.h>
#include "elementi.h"

#define OPEN ((f = fopen("menu.dyn", "r")) != NULL )
FILE *f;

/* NumElementi e` una variabile che deve essere
 * scritta solo dalla funzione load_elementi e la sua corruzione
 * comporta il mal funzionamento del programma e la corruzione
 * del file menu.dyn
 * Analogamente vale per Elementi[][]
 */

int NumElementi;
gchar Elementi[MAX_N_ELEMENTI][2][RECORD_LUN];

int
conta_elementi (void)
{
  // g_print ("Il numero degli elementi  %d", NumElementi);
  return NumElementi;
}


char *
get_elemento (int numero, int parte)
{
  static char temp[RECORD_LUN];

  sprintf (temp, Elementi[numero][parte]);

  return temp;
}

int
load_elementi (void)
{
  int i, k, z, q;
  static int nvolte = 0;
  gchar buf[RECORD_LUN];

  q = 1;
  NumElementi = 0;

  if OPEN
  {
    for (i = 0; i < MAX_N_ELEMENTI && q; i++)
      for (z = 0; z < 2 && q; z++)
      {
	if (fgets (buf, RECORD_LUN, f) == NULL)
	{
	  q = 0;
	  break;
	}
	else
	{
	  /* Variabile di stato globale */
	  /* Meglio aggiornarla qui ma in modo
	   * intelligente, cioe` una volta ogni due (z = 0,1)
	   */
	  NumElementi += z;
	  // g_print (" In Riga %d, ", i);

	  sprintf (Elementi[i][z], buf);

	  /* Bisogna togliere il \n da in fondo alla
	   * riga mentre il \r lo tolgo per compatibilita` con il DOS */
	  for (k = strlen (Elementi[i][z]); k > 0; k--)
	    if (Elementi[i][z][k] == 0x0a || Elementi[i][z][k] == 0x0d)
	      Elementi[i][z][k] = 0;

	  // g_print ("Colonna %d, Carico %s", z, Elementi[i][z]);
	}
      }
    // g_print ("\nIl numero degli elementi  %d\n", NumElementi);


    for (i--; i < MAX_N_ELEMENTI; i++)
      for (; z < 2; z++)
	Elementi[i][z][0] = 0;

    fclose (f);

  }
  else
    g_print ("NON POSSO APRIRE\n");

  nvolte++;

  return NumElementi;
}

int
salva_elementi (void)
{
  int n;

  f = fopen ("menu.dyn", "w");

  for (n = 0; n < NumElementi; ++n)
  {
    if (Elementi[n][0][0] && Elementi[n][1][0])
      fprintf (f, "%s\n%s\n", Elementi[n][0], Elementi[n][1]);
  }
  fclose (f);

  return 0;
}



int
modifica_elemento (int numero, char *nome, char *comando)
{
  if (numero < 0)
    return -2;

  /* Se il numero indice e` piu` alto
   * che non il numero degli elementi allora vuol dire 
   * che si sta aggiungendone uno nuovo e quindi cerco
   * di soddisfare tale esigenza
   */
  if (numero >= NumElementi)
  {
    numero = NumElementi;
    NumElementi++;
  }
  if (strlen (comando) >= RECORD_LUN || strlen (nome) >= RECORD_LUN)
  {
    g_print ("ERRORE: Le stringhe non possono essere piu` lunghe di %d",
	     RECORD_LUN);
    return -3;
  }
  else
  {
    sprintf (Elementi[numero][0], nome);
    sprintf (Elementi[numero][1], comando);
  }

  salva_elementi ();

  return NumElementi;
}


int
cancella_elemento (int numero)
{
  int i;

  /* Controllo che lindice sia
   * contenuto in un range appropriato altrimenti
   * ritorno -1 per segnalare lerrore 
   */
  if (numero >= NumElementi)
    return -1;
  else if (numero < 0)
    return -2;
  else
    g_print ("\nElimino lelemento %d\n", numero);

  /* Scalo gli elementi eliminando 
   * solo quello notificatomi e azzero lultimo avanzato
   */

  NumElementi--;
  for (i = numero; i < NumElementi; i++)
  {
    sprintf (Elementi[i][0], Elementi[i + 1][0]);
    sprintf (Elementi[i][1], Elementi[i + 1][1]);
  }
  Elementi[i][0][0] = 0;
  Elementi[i][1][0] = 0;

  salva_elementi ();

  return 0;
}
